<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Arduino Pinball</title>
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700&display=swap">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">
    <style>
        body {
            font-family: 'Roboto', sans-serif;
            margin:0px;
            padding:0px;
        }
    
        .header {
            text-align: left;
            background-color: #009688; /* Arduino color */
            background-image: url('pattern.png');
            background-repeat: repeat;
            background-size: 200px;
            color: white;
            padding: 20px;
        }
    
        .content {
            display: flex;
            flex-wrap: wrap;
        }
    
        .left-column {
            flex: 1 1 100%;
            padding: 20px;
        }
    
        .right-column {
            flex: 1 1 100%;
            padding: 20px;
        }
    
        @media(min-width: 768px) {
            .left-column {
                flex: 2;
            }
    
            .right-column {
                flex: 1;
            }
        }
    
        .pinout-img {
            display: block;
            margin: 0 auto;
            max-width: 100%;
            height: auto;
        }
    
        .btn-large {
            width: 100%;
            margin-top: 10px;
        }
    
        .progress {
            display: none;
            width: 100%;
            background-color: #f3f3f3;
            border-radius: 4px;
            overflow: hidden;
        }
    
        .progress-bar {
            width: 0;
            height: 40px;
            background-color: #009688;
            transition: width 0.5s ease;
        }

        .changelog {
            background-color: #f5f5f5;
            padding: 20px;
            margin: 20px 0;
            border-radius: 8px;
        }

        .changelog h2 {
            margin-top: 0;
        }


    </style>
    
</head>
    
<body>
    <div class="header">
        <h1>Arduino Pinball</h1>
        <h4>Utilitaire de téléversement depuis le navigateur</h4>
    </div>

    <div class="changelog">
        <h2>Change Log</h2>
        <h3>Fonctionnalités supportées :</h3>
        <ul>
            <li><b>23/05/2024</b> <b>Gestion de bruitages sommaires.</b></li>
            <li><b>23/05/2024</b> <b>Gestion de l'écran et affichage du score.</b></li>
            <li><b>22/05/2024</b> Calcul du score avec prise en compte du bonus et affichage via liaison série.</li>
            <li><b>22/05/2024</b> Gestion des boutons des cibles avec debounce.</li>
            <li><b>22/05/2024</b> Gestion des 5 LEDs des 5 cibles.</li>
            <li><b>22/05/2024</b> Le jeu démarre directement en mode de jeu avec le relay activé.</li>
        </ul>
        <h3>Fonctionnalités non supportées :</h3>
        <ul>
            <li>Attract mode.</li>
            <li>Compte à rebours.</li>
            <li>Initiales HighScore.</li>
            <li>Gestion de la musique et des bruitages avancés.</li>
            <li>Sauvegarde du HighScore.</li>
        </ul>
    </div>

    <div class="content">
        <div class="left-column">
            <img src="Pinout.svg" alt="Pinout Diagram" class="pinout-img">
        </div>

        <div class="right-column">
            <a href="pinball.ino.with_bootloader.hex" download class="btn-large">Sauvegarder dans un .hex</a>
            <button id="uploadBtn" class="btn-large">Téléverser via USB (Chrome)</button>
            <div class="progress">
                <div class="progress-bar"></div>
            </div>
        </div>
    </div>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>

    <script type="module">

        import { SerialPort } from 'https://www.unpkg.com/web-serial-polyfill@1.0.15/dist/serial.js';
        import avrbro from './avrbro.m.js'

        document.getElementById('uploadBtn').addEventListener('click', async () => {
            const progressBarContainer = document.querySelector('.progress');
            const progressBar = document.querySelector('.progress-bar');
            progressBarContainer.style.display = 'block';

            const response = await fetch('pinball.ino.with_bootloader.hex');
            const hexText = await response.text();
            const hexBuffer = avrbro.parseHex(hexText);

            const serial = await avrbro.openSerial({
                baudRate: 115200,
                filters: [{
                    usbVendorId: 0x2341
                }]
            });

            if (serial) {
                let width = 0;
                const interval = setInterval(() => {
                    if (width >= 70) {
                        clearInterval(interval);
                    } else {
                        width += 1;
                        progressBar.style.width = width + '%';
                    }
                }, 300);

                const options = {
                    boardName: 'uno',
                    debug: true
                };
                
                try
                {
                  const success = await avrbro.flash(serial, hexBuffer, options);

                  clearInterval(interval);
                  if (success) {
                      progressBar.style.width = '100%';
                      console.log('.hex file uploaded on board successfully!');
                  }
                  else
                  {
                      progressBar.style.width = '0%';
                      console.log('Upload failed');
                  }
                }
                catch (error)
                {
                    progressBar.style.width = '0%';
                    console.log('Upload failed: ' + error);
                }
                
            } else {
                progressBarContainer.style.display = 'none';
                console.log('Operation canceled by user');
            }
        });

        window.addEventListener('load', () => {
            if (!avrbro.isAvailable()) {
                document.getElementById('noserial').style.display = 'block';
                return;
            } else {
                document.getElementById('actionsButtons').style.display = 'block';
            }
        });
    </script>
</body>

</html>
